import _ from 'lodash';

// 历史表格数据整理 数据结构参照HistoryDataSearchCmd id => table
export const history = ({data}) => {
  const tableData = {
    columns: [],
    dataSource: [],
  };

  if(data.length > 0){
    tableData.columns.push(...[
      {
        title: '序号',
        dataIndex: 'index',
        key: 'index',
      },
      {
        title: '采样时间',
        dataIndex: 'timestamp',
        key: 'timestamp',
      },
    ]);

    const obj = {};
    data.forEach((item, i) => {
      tableData.columns.push({
        title: item.name,
        dataIndex: item.name,
        key: item.name,
      });

      if (_.isArray(item.pairs)) {
        item.pairs.forEach(pair => {
          if (!obj[pair.timestamp]) {
            obj[pair.timestamp] = {};
          }

          obj[pair.timestamp][item.name] = pair.value === 'null' ? null : pair.value;
        });
      }
    });

    let index = 1;
    _.forEach(obj, (o, timestamp) => {
      tableData.dataSource.push({
        index,
        timestamp,
        ...o,
      })
      index++;
    });
  }

  return tableData;
};
