import {
  ActionReducerMap,
  createSelector,
  createFeatureSelector,
  ActionReducer,
  MetaReducer,
} from './store';
import {getReducer} from './model';
import {EffectsModule, Actions, Effect} from './effect';
import {storeFreeze} from 'ngrx-store-freeze';
import {storeLogger} from 'ngrx-store-logger';

//store & effect
export function logger(reducer: ActionReducer<any>): ActionReducer<any> {
  return storeLogger()(reducer);
}

export const states = [];
export const reducers = {};
export const effects = [];
export const KEYS = [];

export const metaReducers: MetaReducer<any>[] = [storeFreeze, logger];

export function AddCore(core) {
  if (core.KEY) {
    KEYS.push(core.KEY);
  }
  if (core.reducers && core.initialState) {
    states[core.KEY] = core.initialState;

    //router !!!
    if (KEYS.length !== 1) {
      reducers[core.KEY] = getReducer(core.reducers, core.initialState);
    }else{
      reducers[core.KEY] = core.reducers;
    }
  }
  if (core.Effects) {
    effects.push(core.Effects);
  }
}
