// 时间法则
export const pTimeRange = {
  begin: beginTime => beginTime.format('YYYY-MM-DD') + ' 00:00:00',
  end: endTime => endTime.format('YYYY-MM-DD') + ' 23:59:59',
  range: function (beginTime, endTime) {
    return {
      beginTime: this.begin(beginTime),
      endTime: this.end(endTime),
    }
  },
}

// 玄黄归一
// export const _dpsParam = {
//   delay: 200,
//   interval: null,
// };
// export const dpsLasted = (callback = () => {}) => {
//   const st = setTimeout(() => {
//     callback();
//   }, _dpsParam.delay);
//
//   if (_dpsParam.interval) {
//     clearTimeout(_dpsParam.interval);
//   }
//   _dpsParam.interval = st;
// }
export class dpsLasted {
  delay = 200;
  interval = null;

  constructor() {
  }

  run(callback = () => {}) {
    if (this.interval) {
      clearTimeout(this.interval);
    }

    this.interval = setTimeout(() => {
      callback();
    }, this.delay);
  }
}
